package com.xzzn.mqttplayer.service;

import com.xzzn.mqttplayer.model.MqttMessageEntity;
import com.xzzn.mqttplayer.repository.MqttMessageRepository;
import org.eclipse.paho.client.mqttv3.*;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;

@Service
public class MqttReceiver {

    private final MqttClient mqttClient;
    private final MqttMessageRepository repository;

    @Value("${mqtt.topic}")
    private String topic;

    public MqttReceiver(MqttClient mqttClient, MqttMessageRepository repository) {
        this.mqttClient = mqttClient;
        this.repository = repository;
    }

    @PostConstruct
    public void init() throws MqttException {
        mqttClient.subscribe(topic, (t, message) -> {
            MqttMessageEntity entity = new MqttMessageEntity();
            entity.setTopic(t);
            entity.setPayload(new String(message.getPayload()));
            repository.save(entity);
        });
    }
}
